Nothing is - together with Null - at the bottom of Scala's type hierarchy.

Nothing is a subtype of every other type (including Null); there exist no 
instances of this type. Although type Nothing is uninhabited, it is nevertheless 
useful in several ways. For instance, the Scala library defines a value 
scala.collection.immutable.Nil of type List[Nothing]. Because lists are covariant in Scala, 
this makes scala.collection.immutable.Nil an instance of List[T], for any element of type T.

Another usage for Nothing is the return type for methods which never return normally. 
One example is method error in sys, which always throws an exception.

--------

Null is - together with scala.Nothing - at the bottom of the Scala type hierarchy.

Null is the type of the null literal. It is a subtype of every type except those of
 value classes. Value classes are subclasses of AnyVal, which includes primitive 
 types such as Int, Boolean, and user-defined value classes.

Since Null is not a subtype of value types, null is not a member of any such type. 
For instance, it is not possible to assign null to a variable of type scala.Int.
